// Adam Gashlin's year end biology program
// Original code except for this message and slight intro & outro revisions
// halleyscometsoftware@hotmail.com

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "graphics.h"
#include "mouse.h"
#include "buttons.h"
#include "trans.h"
#include "flame.h"
#include "bg.h"
#include "pcx.h"

#include "intro.h"

#include "punnett.h"
#include "blood.h"
#include "sex.h"
#include "hw.h"
#include "chisq.h"

void PunnetMain(void) {
   int x, y;
   bool b, depressed=false,willtolive=true;
   button biomenu[4];
   buttonset biodd;

   RGB_color *pal;

   Set_Video_Mode(VGA256);

   Cls();

   Restore_Default_Palette();

   pal = Init_BG_Pal();

   Blank_Palette();
   
   Draw_BG();

   Initialize_Button(0,13,128,24,false,7,8,"Autosomal",2,biomenu[0]);
   Initialize_Button(0,25,128,36,false,7,8,"Blood Type",2,biomenu[1]);
   Initialize_Button(0,37,128,49,false,7,8,"Sex Linked",2,biomenu[2]);
    
   Initialize_Button_Set(4, biomenu, -1, RADIOBUTTON, biodd);

   Show_Cursor();

   Fade_Into(pal);

   delete pal;

   while (willtolive) {
      Mouse_Interface(x,y,b,depressed);

      Check_Button_Set(x,y,b,biodd,depressed);
      
      if (biodd.a[0].buttonstate || biodd.a[1].buttonstate || biodd.a[2].buttonstate) willtolive=false;

      while (Vertical_Retrace()) {}
      while (!Vertical_Retrace()) {}
      Rotate_Palette();
   }
   Fade_Out();

   Hide_Cursor();
      
   if (biodd.a[0].buttonstate) {Autosomal();}
   if (biodd.a[1].buttonstate) {BloodType();}
   if (biodd.a[2].buttonstate) {SexLinked();}

   return;
}

void FireStuff(void) {
   Set_Video_Mode(VGA256);

   CBlit_Scaled_String("Adam Gashlin's Bio Program", 92, 255, 0, false,
                1.0,1.0);
   
   Run_Fire_Effect(56,92,264,100,0,56,265,100);

   return;
}

int main(void) {
   FireStuff();
   
   int x, y;
   bool b, depressed=false,willtolive, must_go_on=true;
   button biomenu[5];
   buttonset biodd;

   RGB_color * pal;
   
   while (must_go_on) {
      willtolive=true;


      Set_Video_Mode(VGA256);

      Cls();

      Restore_Default_Palette();

      pal = Init_BG_Pal();

      Blank_Palette();

      Draw_BG();

      Initialize_Button(0,13,128,24,false,7,8,"Punnett Squares",2,biomenu[0]);
      Initialize_Button(0,25,128,36,false,7,8,"Hardy-Weinberg",2,biomenu[1]);
      Initialize_Button(0,37,128,49,false,7,8,"Chi Square",2,biomenu[2]);
      Initialize_Button(0,50,128,64,false,7,8,"Introduction",2,biomenu[3]);
      Initialize_Button(0,65,128,79,false,7,8,"Exit",2,biomenu[4]);
   
      Initialize_Button_Set(5, biomenu, -1, RADIOBUTTON, biodd);

      Show_Cursor();

      Fade_Into(pal);

      delete pal;

      while (willtolive) {
         Mouse_Interface(x,y,b,depressed);

         Check_Button_Set(x,y,b,biodd,depressed);
      
         if (biodd.a[0].buttonstate || biodd.a[1].buttonstate || biodd.a[2].buttonstate || biodd.a[3].buttonstate || biodd.a[4].buttonstate) willtolive=false;

         while (Vertical_Retrace()) {}
         while (!Vertical_Retrace()) {}
         Rotate_Palette();
      }
      Fade_Out();

      Hide_Cursor();
      
      if (biodd.a[0].buttonstate) {PunnetMain();}
      if (biodd.a[1].buttonstate) {HardyW();}
      if (biodd.a[2].buttonstate) {chiMain();}
      if (biodd.a[3].buttonstate) {Intro();}
      if (biodd.a[4].buttonstate) {must_go_on=false;}
   }

   Set_Video_Mode(TEXT_MODE);

   cout << "Thank you so much a for to using my program.\n";

   return 0;
}
