void GetBloodInput(char * &male, char * &female) {
   int conx=0, cony=0;
   bool fadedin = false;
   RGB_color * pal;

   Set_Video_Mode(VGA256);
   
   pal = Init_BG_Pal();

   Cls();
   
   Blank_Palette();

   Draw_BG();

   Blit_Con_String("Blood Type Punnett Square Generator", conx, cony, 15, 0, true);
   CR(conx,cony);
   Blit_Con_String("Blood types should be in AA+- format.",conx,cony,15,0,true);
   CR(conx,cony);

   do {   
      Blit_Con_String("Enter male parent genotype. ", conx, cony, 15, 0, true);
      if (!fadedin) {Fade_Into(pal); delete pal; fadedin=true;}
      male = Input_Con_String(conx, cony, 15, 0, 4,true);
      LINEFEED
      male[0] = male[0] & 0xCF;
      male[1] = male[1] & 0xCF;
      

   } while (strlen(male) != 4);
   
   
   do {
      Blit_Con_String("Enter female parent genotype. ", conx, cony, 15, 0, true);
      female = Input_Con_String(conx,cony,15,0,4,true);
      LINEFEED
      female[0] = female[0] & 0xCF;
      female[1] = female[1] & 0xCF;
   } while (strlen(female) != 4);

   Fade_Out();

   return;
}

void Graph_Blood_Allele(int x, int y, char c, char rh) {
   if (c == 'O') {
      Blit_Scaled_Character(x, y, 'i', 15, 0, true, 2.0, 2.0);
   } else {
      Blit_Scaled_Character(x, y, 'I', 15, 0, true, 2.0, 2.0);
   }

   Blit_Character(x+CHAR_WIDTH*2, y+CHAR_HEIGHT*2, c, 15, 0, true);
   Blit_Scaled_Character(x+CHAR_WIDTH*3, y, rh, 15, 0, true, 2.0, 2.0);

   return;
}

char * Mate_Blood(char * male, char * female) {
   char * child = new char [5];
   child[0] = male[0];
   child[1] = female[0];
   child[2] = male[1];
   child[3] = female[1];
   child[4] = 0;
   if (child[0] > child[1]) {
      child[0] = female[0];
      child[1] = male[0];
   }
   if (child[2] > child[3]) { 
      child[2] = female[1];
      child[3] = male[1];
   }
   return child;
}

void Graph_Blood_Gene(int x, int y, char * c, bool small=false) {
   float scale=1.0;
   if (small) scale = 0.75;
   
   if (c[0] == 'O') {
      Blit_Scaled_Character(x, y, 'i', 15, 0, true, scale*2, scale*2);
   } else {
      Blit_Scaled_Character(x, y, 'I', 15, 0, true, scale*2, scale*2);
   }
   x+=CHAR_WIDTH*2*scale;
   Blit_Character(x, y+CHAR_HEIGHT*2*scale, c[0], 15, 0, true);
   
   x+=CHAR_WIDTH*scale;
   if (c[1] == 'O') {
      Blit_Scaled_Character(x, y, 'i', 15, 0, true, scale*2, scale*2);
   } else {
      Blit_Scaled_Character(x, y, 'I', 15, 0, true, scale*2, scale*2);
   }
   x+=CHAR_WIDTH*2*scale;
   Blit_Character(x, y+CHAR_HEIGHT*2*scale, c[1], 15, 0, true);

   x+=CHAR_WIDTH*scale;
   Blit_Scaled_String(c+2,x,y, 15, 0, true, scale*2, scale*2);

   return;
}

void Graph_Blood(char * male, char * female) {
   int conx=48, cony=1, x, y, c;
   char males[3]={11,32,0}, females[3]={12,32,0};
   char ** children = new char * [16];
   int ratio[8];

   Cls();

   Restore_Default_Palette();

   RGB_color * pal = Init_BG_Pal();

   Blank_Palette();

   Draw_BG();

   //Draw header (male x female)
   cony +=3;
   Blit_Con_String(males, conx, cony, 15, 0, true);
   cony -=3;
   Graph_Blood_Gene(conx, cony, male); conx+=10*CHAR_WIDTH;
   cony +=3;
   Blit_Con_String(" x ", conx, cony, 15, 0, true);
   Blit_Con_String(females, conx, cony, 15, 0, true);
   cony -=3;
   Graph_Blood_Gene(conx, cony, female);
   
   //Draw eggs
   conx = 41;
   cony = 30;

   Graph_Blood_Allele(conx, cony, female[0], female[2]);
   conx += 60;
   Graph_Blood_Allele(conx, cony, female[1], female[2]);
   conx += 60;
   Graph_Blood_Allele(conx, cony, female[0], female[3]);
   conx += 60;
   Graph_Blood_Allele(conx, cony, female[1], female[3]);

   //Draw sperm
   conx = 1;
   cony = 60;

   Graph_Blood_Allele(conx, cony, male[0], male[2]);
   cony += 30;
   Graph_Blood_Allele(conx, cony, male[1], male[2]);
   cony += 30;
   Graph_Blood_Allele(conx, cony, male[0], male[3]);
   cony += 30;
   Graph_Blood_Allele(conx, cony, male[1], male[3]);

   //Draw grid
   conx = 42;
   cony = 58;

   for (x=0; x < 5; x++) {
      V_Line(x*60+conx, cony, cony+30*4, 15);
   }
   
   for (y=0; y < 5; y++) {
      H_Line(conx, conx+60*4, y*30+cony, 15);
   }

   //Fill table
   c=0;
   char lmale[2],lfemale[2], * temp;

   for (y=0; y < 4; y++) {
      for (x=0; x < 4; x++) {
         
         switch (x) {
            case 0:
               lfemale[0] = female[0]; 
               lfemale[1] = female[2];
               break;
            case 1:
               lfemale[0] = female[1];
               lfemale[1] = female[2];
               break;
            case 2:
               lfemale[0] = female[0];
               lfemale[1] = female[3];
               break;
            case 3:
               lfemale[0] = female[1];
               lfemale[1] = female[3];
               break;
         }
         switch (y) {
            case 0:
               lmale[0] = male[0]; 
               lmale[1] = male[2];
               break;
            case 1:
               lmale[0] = male[1];
               lmale[1] = male[2];
               break;
            case 2:
               lmale[0] = male[0];
               lmale[1] = male[3];
               break;
            case 3:
               lmale[0] = male[1];
               lmale[1] = male[3];
               break;
         }
         
         temp = Mate_Blood(lmale,lfemale);
         Graph_Blood_Gene(conx+x*60, y*30+cony+4, temp, true);
         children[c] = temp;
         c++;
      }
   }


   //Phenotypic ratios
   //0:  O-
   //1:  A-
   //2:  B-
   //3: AB-
   //4:  O+
   //5:  A+
   //6:  B+
   //7: AB+

   char * bloodtype[8] = {"O-","A-","B-","AB-","O+","A+","B+","AB+"};

   int typetot,printed=0;
   for (c=0; c < 8; c++) {
      ratio[c] = 0;
   }
   for (c=0; c < 16; c++) {
      typetot=0;
      if (children[c][2] == '+' || children[c][3] == '+') typetot+=4;
      if (children[c][0] == 'A' || children[c][1] == 'A') typetot++;
      if (children[c][0] == 'B' || children[c][1] == 'B') typetot+=2;
      ratio[typetot]++;
      delete children[c];
   }
   conx=0;
   cony=182;

   typetot = GCF(ratio,8);

   bool inorder=false;
   
   while (!inorder) {
      inorder=true;
      for (x=0; x < 7 ; x++) {
         if (ratio[x] < ratio[x+1]) {
            inorder=false;
            c    = ratio[x];
            temp = bloodtype[x];
            ratio[x]  = ratio[x+1];
            bloodtype[x] = bloodtype[x+1];
            ratio[x+1]  = c;
            bloodtype[x+1] = temp;
         }
      }
   }

   Blit_Con_String("Phenotypic Ratio: ",conx,cony,15,0,true);
   
   for (c=0; c < 8; c++) {
      if (ratio[c] != 0) {
         Blit_Con_String(bloodtype[c], conx, cony, 15, 0, true);
         Blit_Con_String(":", conx,cony,15,0,true);
         Blit_Con_String(itoa(ratio[c]/typetot, "0123456789", 10), conx, cony, 15, 0, true);
         Blit_Con_String(" ", conx,cony,15,0,true);
         printed++;
         if (printed==4) {CR(conx,cony); printed=0; conx=152;}
      }
   }
   
   Fade_Into(pal);
   
   return;
}

void BloodType(void) {
   char *male, *female;

   Set_Video_Mode(VGA256);
   
   GetBloodInput(male,female);

   Graph_Blood(male, female);
   
   while (!kbhit()) {
      Rotate_Palette();
   }
   getch();

   Fade_Out();

   return;
}
